(***********************************************************************)
(*                                                                     *)
(*                          OCamlP3l                                   *)
(*                                                                     *)
(* (C) 2004-2006                                                       *)
(*             Roberto Di Cosmo (dicosmo@dicosmo.org)                  *)
(*             Zheng Li (zli@lip6.fr)                                  *)
(*             Pierre Weis (Pierre.Weis@inria.fr)                      *)
(*             Francois Clement (Francois.Clement@inria.fr)            *)
(*                                                                     *)
(* Based on original Ocaml P3L System                                  *)
(* (C) 1997 by                                                         *)
(*             Roberto Di Cosmo (dicosmo@ens.fr)                       *)
(*             Marco Danelutto (marcod@di.unipi.it)                    *)
(*             Xavier Leroy  (Xavier.Leroy@inria.fr)                   *)
(*             Susanna Pelagatti (susanna@di.unipi.it)                 *)
(*                                                                     *)
(* This program is free software; you can redistribute it and/or       *)
(* modify it under the terms of the GNU Library General Public License *)
(* as published by the Free Software Foundation; either version 2      *)
(* of the License, or (at your option) any later version.              *)
(*                                                                     *)
(* This program is distributed in the hope that it will be useful,     *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of      *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *)
(* GNU Library General Public License for more details.                *)
(*                                                                     *)
(***********************************************************************)

(* $Id: grafp3l.mli,v 1.2 2007/01/12 21:08:29 weis Exp $ *)

type color = P3lstream.color;;

type ('a, 'b) tree =
   | Seq of string * color
   | Pipe of ('a, 'b) tree list
   | Farm of ('a, 'b) tree * int * (color * color list)
   | Map of ('a, 'b) tree * int * (color * color list)
   | Reduce of ('a, 'b) tree * int * (color * color list)
   | Loop of ('a, 'b) tree * color;;

val seq :
  ?col:color -> (unit -> 'a -> 'b) -> ('a P3lstream.s, 'b P3lstream.s) tree;;

val pipeline : ('a, 'b) tree -> ('b, 'c) tree -> ('a, 'c) tree;;

val ( ||| ) : ('a, 'b) tree -> ('b, 'c) tree -> ('a, 'c) tree;;

val farm :
  ?col:color -> ?colv:color list -> ('a, 'b) tree * int -> ('a, 'b) tree;;

val mapvector :
  ?col:color -> ?colv:color list ->
  ('a P3lstream.s, 'b P3lstream.s) tree * int ->
  ('a array P3lstream.s, 'b array P3lstream.s) tree;;

val reducevector :
  ?col:color -> ?colv:color list ->
  (('a * 'a) P3lstream.s, 'a P3lstream.s) tree * int ->
  ('a array P3lstream.s, 'a P3lstream.s) tree;;

val loop : ?col:color -> ('a -> bool) * ('a P3lstream.s, 'a P3lstream.s) tree
 -> ('a P3lstream.s, 'a P3lstream.s) tree;;

val parfun : (unit -> ('a, 'b) tree) -> 'a -> 'b;;

val pardo : (unit -> unit) -> unit;;
